#include "System.h"
#include "Sprite.h"
#include "BSDec.h"
#include "DataManager.h"

/******************************************/

u_char		bsdata[32*1024];		// BS encoded Image
u_char		imgdata[320*240*3];		// Raw 24 bits decoded Image
u_char		rle_buffer[BS_RLE_BUFFER_SIZE];	// Decode Buffer

/******************************************/

int			main(void)
{
	int		i, j = 0;
	GsOT	*ot;
	int		cputime, gputime;

	// Set 24bits mode
	System_Init(MODE_PAL, VMODE_24BITS, 320, 240, GsNONINTER, 0);

	DataManager_Init();
	DataManager_Load("DATA\\EL1_3.BS", bsdata);	// Load our file (from cd or from pc depending on CDROM_RELEASE flag compilation)

	BS_SetClipping(320, 240);	// Set Clipping if we ask to display on screen area
	BS_Decode((u_long *)bsdata, (u_long *)rle_buffer, (u_long *)imgdata, 320, 240, BS_OUTPUT_24BITS);	// Decode the BS image from bsdata buffer to imgdata buffer in 24 bits
	BS_Display((u_long *)imgdata, 0, 0, 320, 240, BS_OUTPUT_24BITS, false);	// Display our image at 0,0 Size 320x240 in 24 bits

	GsSwapDispBuff();	// Be sure we are displaying from VRAM 0,0

	// Wait Loop
	while (!IsPadPress(Pad1Start))
	{
	}

	System_Exit();
	return (0);
}
